<?php

namespace FiloBlu\StockaFix\Model\Report;

use FiloBlu\StockaFix\Model\ResourceModel\Report\CollectionFactory;

/**
 * Class DataProvider
 * @package FiloBlu\StockaFix\Model\Report
 */
class DataProvider extends \Magento\Ui\DataProvider\AbstractDataProvider
{
    /**
     * @param string $name
     * @param string $primaryFieldName
     * @param string $requestFieldName
     * @param CollectionFactory $contactCollectionFactory
     * @param array $meta
     * @param array $data
     */
    public function __construct(
        $name,
        $primaryFieldName,
        $requestFieldName,
        CollectionFactory $contactCollectionFactory,
        array $meta = [],
        array $data = []
    )
    {
        $this->collection = $contactCollectionFactory->create();
        parent::__construct($name, $primaryFieldName, $requestFieldName, $meta, $data);
    }

    /**
     * @return array
     */
    public function getData()
    {
        if (isset($this->loadedData)) {
            return $this->loadedData;
        }

        $items = $this->collection->getItems();
        $this->loadedData = [];

        foreach ($items as $report) {

            $id = $report->getId();
            // report
            $this->loadedData[$id]['report']['report_id'] = $report->getData('report_id');
            $this->loadedData[$id]['report']['active'] = $report->getData('active');
            $this->loadedData[$id]['report']['name'] = $report->getData('name');
            $this->loadedData[$id]['report']['description'] = $report->getData('description');

            // schedule
            $this->loadedData[$id]['schedule']['schedule_frequency'] = $report->getData('schedule_frequency');

            // menu
            $this->loadedData[$id]['menu']['menu_label'] = $report->getData('menu_label');
            $this->loadedData[$id]['menu']['menu_label'] = $report->getData('menu_label');

            // receivers
            $this->loadedData[$id]['receivers']['receiver_emails'] = $report->getData('receiver_emails');

            // source
            $this->loadedData[$id]['source']['sql'] = $report->getData('sql');
            $this->loadedData[$id]['source']['id_label'] = $report->getData('id_label');

        }

        return $this->loadedData;
    }
}